<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die('Restricted access');

class JSNSampleDataHelper
{
	var $_template_folder_path  = '';
	var $_template_folder_name 	= '';

	function JSNSampleDataHelper()
	{
		$this->_setPhysicalTmplInfo();
	}

	/**
	 * Initialize Physical template information variable
	 *
	 */
	function _setPhysicalTmplInfo()
	{
		$template_name 					= explode(DS, str_replace(array('\includes\lib', '/includes/lib'), '', dirname(__FILE__)));
		$template_name 					= $template_name [count( $template_name ) - 1];
		$path_base 						= str_replace(DS."templates".DS.$template_name.DS.'includes'.DS.'lib', "", dirname(__FILE__));
		$this->_template_folder_name    = $template_name;
		$this->_template_folder_path 	= $path_base . DS . 'templates' .  DS . $template_name;
	}
	function checkExistingExtension($data)
	{
		$config 			= new JConfig();
		$database_prefix	= $config->dbprefix;
		$db	 				= JFactory::getDBO();
		$array_extentions 	= array();
		if ($data && is_array($data))
		{
	        foreach ($data as $value)
			{
				$author = $value->author;

				if ($author != '' && strtolower(trim($author)) == "joomlashine")
				{
					$name 			= $value->name;
					$query 			= 'SELECT COUNT(extension_id) FROM #__extensions c WHERE c.element = "com_'.$name.'" AND c.type = "component" GROUP BY c.element';
					$db->setQuery($query);
					$result 		=  $db->loadRow();
					if ($result[0] > 0)
					{
						$array_extentions [$name]['exist'] = 1;
					}
					else
					{
						$array_extentions [$name]['exist'] = 0;
					}

					if (isset($value->manifest_path) && trim($value->manifest_path) != '')
					{
						$array_extentions [$name]['manifest_path'] = str_replace('/', DS, trim($value->manifest_path));
					}
					else
					{
						$array_extentions [$name]['manifest_path'] = '';
					}
				}
			}
		}
		return 	$array_extentions;
	}

	function deleteRecordAssetsTableByName($name)
	{
		$db	 	= JFactory::getDBO();
		$where	= array();
		if (count($name))
		{
			foreach ($name as $value)
			{
				$where [] = 'LOWER(name) LIKE '.$db->Quote('%'.'com_'.$value.'%', false);
			}
			$where 	= (count($where) ? ' WHERE '. implode(' OR ', $where) : '');
			$query 	= 'DELETE FROM #__assets'.$where;
			$db->setQuery($query);
			$db->query();
		}
		return false;
	}

	function unpackPackage($p_file)
	{
		jimport('joomla.filesystem.archive');
		$obj_read_xml_file 	= new JSNReadXMLFile();
		$template_manifest	= $obj_read_xml_file->getTemplateManifestFileInformation();
		$tmp_dest 			= JPATH_ROOT.DS.'tmp';
		$prefix				= $template_manifest['name'].'_sample_data_';
		$tmpdir				= uniqid($prefix);
		$archive_name 		= $p_file;
		$extract_dir 		= JPath::clean($tmp_dest.DS.$tmpdir);
		$archive_name 		= JPath::clean($tmp_dest.DS.$archive_name);
		$result				= @JArchive::extract($archive_name, $extract_dir);
		if ($result)
		{
			$path = $tmp_dest.DS.$tmpdir;
			return $path;
		}
		return false;
	}

	function installSampleData($data)
	{
		$db			= JFactory::getDBO();
		$queries 	= array();
		foreach ($data as $rows)
		{
			$datas 	= $rows->queries;
			if(count($datas))
			{
				foreach ($datas as $value)
				{
					$queries [] = $value;
				}
			}
		}

		if (count($queries))
		{
			foreach ($queries as $query)
			{
				$query = trim($query);
				if ($query != '')
				{
					$db->setQuery($query);
					if (!$db->query())
					{
						return false;
					}
				}
			}
			return true;
		}
		return false;
	}

	function deleteSampleDataFolder($path)
	{
		$path = JPath::clean($path);
		if (JFolder::exists($path))
		{
			JFolder::delete($path);
			return true;
		}
		return false;
	}

	function deleteSampleDataFile($file_name)
	{
		$path = JPATH_ROOT.DS.'tmp'.DS.$file_name;

		if(JFile::exists($path))
		{
			JFile::delete($path);
			return true;
		}
		return false;
	}

	function returnError($result, $msg)
	{
		global $error;
		$error = $msg;
	}

	function getNonBasicModule()
	{
		$db					= JFactory::getDBO();
		$str_query 			= '';
		$str_field 			= '';
		$arrayValue			= array();
		$field_module 		= array();
		$queries			= array();

		$table_info_module 	= $db->getTableFields('#__modules', false);
		foreach ($table_info_module['#__modules'] as $key =>$value)
		{
			$field_module [] = $value->Field;
		}

		$str_field 			= implode(',', $field_module);
		$query 				= "SELECT " . implode(',', $field_module) . " FROM #__modules WHERE `module` NOT IN ('mod_login', 'mod_stats', 'mod_users_latest', "
								." 'mod_footer', 'mod_stats', 'mod_menu', 'mod_articles_latest', 'mod_languages', 'mod_articles_category', "
								." 'mod_whosonline', 'mod_articles_popular', 'mod_articles_archive', 'mod_articles_categories', "
								." 'mod_articles_news', 'mod_related_items', 'mod_search', 'mod_random_image', 'mod_banners', "
								." 'mod_wrapper', 'mod_feed', 'mod_breadcrumbs', 'mod_syndicate', 'mod_custom', 'mod_weblinks') AND `client_id` = 0";
		$db->setQuery($query);
		$rows_module_query = $db->loadAssocList();

		foreach ($rows_module_query as $value)
		{
			reset($field_module);
			foreach ($field_module as $field_value)
			{
				if ($value[$field_value] == '')
				{
					$str_query .= '"", ';
				}
				else
				{
					if($field_value == 'id')
					{
						$str_query .= '"null", ';
					}
					elseif ($field_value == 'published'){
						$str_query .= '"0", ';
					}
					elseif ($field_value == 'params')
					{
						$str_query .= '"'.str_replace('"', '\"', $value['params']).'", ';
					}
					else
					{
						$str_query .= '"'.$value[$field_value].'", ';
					}
				}
			}
			$str_query = substr($str_query, 0 , -2);
			$queries [] = 'INSERT INTO #__modules ('.$str_field.') VALUES ('.$str_query.')';
			$str_query = '';
		}
		return $queries;
	}

	function getNonBasicAdminModule()
	{
		$db					= JFactory::getDBO();
		$str_query 			= '';
		$str_field 			= '';
		$arrayValue			= array();
		$field_module 		= array();
		$queries			= array();

		$table_info_module 	= $db->getTableFields('#__modules', false);
		foreach ($table_info_module['#__modules'] as $key =>$value)
		{
			$field_module [] = $value->Field;
		}
		$str_field 			= implode(',', $field_module);
		$query 				= "SELECT " . implode(',', $field_module) . " FROM #__modules WHERE `id` NOT IN (2, 3, 4, 6, 7, 8, 9, 10, 12, 13, 14, 15, 70) AND `client_id` = 1";
		$db->setQuery($query);
		$rows_module_query = $db->loadAssocList();

		foreach ($rows_module_query as $value)
		{
			reset($field_module);
			foreach ($field_module as $field_value)
			{
				if ($value[$field_value] == '')
				{
					$str_query .= '"", ';
				}
				elseif ($field_value == 'published'){
					$str_query .= '"0", ';
				}
				else
				{
					if($field_value == 'id')
					{
						$str_query .= '"null", ';
					}
					else
					{
						$str_query .= '"'.$value[$field_value].'", ';
					}
				}
			}
			$str_query = substr($str_query, 0 , -2);
			$queries [] = 'INSERT INTO #__modules ('.$str_field.') VALUES ('.$str_query.' )';
			$str_query = '';
		}
		return $queries;
	}

	function deleteNonBasicAdminModule()
	{
		$db	= JFactory::getDBO();
		$query = 'DELETE FROM #__modules WHERE `id` NOT IN (2, 3, 4, 6, 7, 8, 9, 10, 12, 13, 14, 15, 70) AND `client_id` = 1';
		$db->setQuery($query);
		$db->query();
	}

	function runQueryNonBasicModule($queries, $admin = false)
	{
		$db	= JFactory::getDBO();
		if(count($queries))
		{
			foreach ($queries as $query)
			{
				$query = trim($query);
				if ($query != '')
				{
					$db->setQuery($query);
					$db->query();
					if($admin)
					{
						$id  = $db->insertid();
						$this->insertModuleMenu($id);
					}
				}
			}
		}
		return true;
	}

	function login($username, $password)
	{
		jimport('joomla.user.helper');
		$app 					 = JFactory::getApplication();
		$credentials 			 = array();
		$credentials['username'] = $username;
		$credentials['password'] = $password;

		// Get the log in options.
		$options = array();

		// Perform the login action
		$error = $app->login($credentials, $options);

		// Check if the log in succeeded.
		if (!JError::isError($error) && $error)
		{
			return true;
		}
		else
		{

			return false;
		}
	}

	function setDefaultTemplate($template_name)
	{
		if ($template_name != '')
		{
			$db 	= JFactory::getDBO();
			$query  = 'UPDATE #__template_styles SET home = 0 WHERE client_id = 0';
			$db->setQuery($query);
			$db->query();
			$query = 'UPDATE #__template_styles SET home = 1 WHERE client_id = 0 AND template = '.$db->quote($template_name);
			$db->setQuery($query);
			$db->query();
			return true;
		}
		else
		{
			return false;
		}
	}

	function checkTmpFolderPermission()
	{
		$folderpath = JPATH_ROOT.DS.'tmp';
		if (!is_writable($folderpath))
		{
			$msg = 'Folder <strong>/tmp</strong> must be <strong>writable</strong> during the process';
			JError::raiseWarning('SOME_ERROR_CODE', $msg);
			return false;
		}
		return true;
	}

	function getDomain()
	{
		$pathURL = array();
		$uri	= JURI::getInstance();
		$pathURL['prefix'] = $uri->toString(array('host'));
		return $pathURL['prefix'];
	}

	function getUserActions()
	{
		$user	 = JFactory::getUser();
		$result	 = new JObject;
		$actions = array('core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.delete');
		foreach ($actions as $action)
		{
			$result->set($action, $user->authorise($action, 'com_templates'));
		}
		return $result;
	}

	function getThirdExtensionMenus()
	{
		$db					= JFactory::getDBO();
		$str_query 			= '';
		$sub_str_query 		= '';
		$str_field 			= '';
		$arrayValue			= array();
		$field_menu 		= array();
		$queries			= array();
		$sub_queries		= array();
		$menu_info_module 	= $db->getTableFields('#__menu', false);
		foreach ($menu_info_module['#__menu'] as $key =>$value)
		{
			$field_menu [] = $value->Field;
		}
		$str_field 			= implode(',', $field_menu);
		$query 				= "SELECT " . implode(',', $field_menu) . " FROM #__menu WHERE `client_id` = 1 AND `parent_id` = 1 ORDER BY id ASC";
		$db->setQuery($query);
		$rows_menu_query = $db->loadAssocList();
		$defined			= array('menutype', 'client_id', 'title', 'alias', 'type', 'published', 'component_id', 'img', 'home', 'link');
		foreach ($rows_menu_query as $value)
		{
			reset($field_menu);
			$sub_queries = array();
			foreach ($field_menu as $field_value)
			{
				if ($value[$field_value] == '')
				{
					$str_query .= '"", ';
				}
				else
				{
					if($field_value == 'id')
					{
						$str_query .= 'null, ';
					}
					else
					{
						$str_query .= '"'.$value[$field_value].'", ';
					}
				}
			}
			$str_query = substr($str_query, 0 , -2);
			$queries [strtolower($value['title'])]['parent']= 'INSERT INTO #__menu ('.$str_field.') VALUES ('.$str_query.' )';
			$sub_query = "SELECT " . implode(',', $field_menu) . " FROM #__menu WHERE `client_id` = 1 AND `parent_id` = ". (int) $value['id']. ' ORDER BY id ASC';

			$db->setQuery($sub_query);
			$rows_sub_menu_query = $db->loadAssocList();

			if (count($rows_sub_menu_query))
			{
				foreach ($rows_sub_menu_query as $sub_value)
				{
					$sub_menu_data = array();
					reset($field_menu);
					foreach ($field_menu as $sub_field_value)
					{
						if (in_array($sub_field_value, $defined))
						{
							if ($sub_value[$sub_field_value] == '')
							{
								$sub_menu_data[$sub_field_value] = '';
							}
							else
							{
								$sub_menu_data[$sub_field_value] = $sub_value[$sub_field_value];
							}
						}
					}
					$sub_queries [] = $sub_menu_data;
				}

			}
			$queries [strtolower($value['title'])]['sub']= $sub_queries;

			$str_query = '';
		}
		return $queries;
	}

	function restoreThirdExtensionMenus($data)
	{
		$db	= JFactory::getDBO();
		if (count($data))
		{
			foreach ($data as $menu)
			{
				$db->setQuery($menu['parent']);
				$db->query();
				$id  		= $db->insertid();
				$array_id 	=  array('parent_id'=>$id);
				if (count($menu['sub']))
				{
					foreach ($menu['sub'] as $sub_menu)
					{
						$table = JTable::getInstance('menu');
						$sub_menu = $sub_menu;
						$tmp_sub_data = array_merge($sub_menu, $array_id);
						if (!$table->setLocation($id, 'last-child') || !$table->bind($tmp_sub_data) || !$table->check() || !$table->store()){}
					}
				}
			}
		}
	}

	function insertModuleMenu($moduleID)
	{
		$db 	= JFactory::getDBO();
		$query  = 'INSERT INTO #__modules_menu (moduleid, menuid) VALUES ("'.$moduleID.'", "0")';
		$db->setQuery($query);
		$db->query();
	}

	function rebuildMenu()
	{
		$db 	= JFactory::getDbo();
		$table 	= JTable::getInstance('Menu', 'JTable');

		if (!$table->rebuild())
		{
			$this->setError($table->getError());
			return false;
		}

		$db->setQuery(
			'SELECT id, params' .
			' FROM #__menu' .
			' WHERE params NOT LIKE '.$db->quote('{%') .
			'  AND params <> '.$db->quote('')
		);

		$items = $db->loadObjectList();
		if ($error = $db->getErrorMsg())
		{
			return false;
		}

		foreach ($items as &$item)
		{
			$registry = new JRegistry;
			$registry->loadString($item->params);
			$params = (string)$registry;

			$db->setQuery(
				'UPDATE #__menu' .
				' SET params = '.$db->quote($params).
				' WHERE id = '.(int) $item->id
			);
			if (!$db->query())
			{
				return false;
			}

			unset($registry);
		}
		// Clean the cache
		$this->cleanCache('com_modules');
		$this->cleanCache('mod_menu');
		return true;
	}

	function cleanCache($group)
	{
		$conf = JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> $group,
			'cachebase'		=> $conf->get('cache_path', JPATH_SITE.DS.'cache')
		);
		jimport('joomla.cache.cache');
		$cache = JCache::getInstance('callback', $options);
		$cache->clean();
	}

	function copyContentFromFilesFolder($path)
	{
		$folderPath = $path.DS.'files';
		if (JFolder::exists($folderPath))
		{
			$fileList 	= JFolder::files($folderPath);
			$folderList = JFolder::folders($folderPath);
			if ($fileList !== false)
			{
				foreach ($fileList as $file)
				{
					if (JFile::exists($folderPath.DS.$file) && substr($file, 0, 1) != '.')
					{
						JFile::copy($folderPath.DS.$file, JPATH_ROOT.DS.$file);
					}
				}
			}

			if ($folderList !== false)
			{
				foreach ($folderList as $folder)
				{
					if (JFolder::exists($folderPath.DS.$folder))
					{
						JFolder::copy($folderPath.DS.$folder, JPATH_ROOT.DS.$folder, '', true);
					}
				}
			}

			return true;
		}
		return false;
	}

	function getPackageFromUpload()
	{
		$install_file = JRequest::getVar('install_package', null, 'files', 'array');
		if (!(bool) ini_get('file_uploads'))
		{
			$msg 	= 'File upload function is disabled, please enable it in file "php.ini"';
			JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
			return false;
		}
		if (!extension_loaded('zlib'))
		{
			$msg = 'Zlib library is disabled, please enable it in file "php.ini"';
			JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
			return false;
		}
		if ($install_file['name'] == '')
		{
			$msg 	= 'Sample data package is not selected, please download and select it';
			JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
			return false;
		}
		if (JFile::getExt($install_file['name']) != 'zip')
		{
			$msg = 'Sample data package has incorrect format, please use exactly the file you downloaded';
			JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
			return false;
		}
		$tmp_dest 	= JPath::clean(JPATH_ROOT.DS.'tmp'.DS.$install_file['name']);
		$tmp_src	= $install_file['tmp_name'];
		if (!JFile::upload($tmp_src, $tmp_dest))
		{
			$msg = 'Folder "tmp" is Unwritable, please set it to Writable (chmod 777). You can set the folder back to Unwritable after sample data installation';
			JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
			return false;
		}
		return 	$install_file['name'];
	}

	function installSampleDataManually()
	{
		$filename 			= $this->getPackageFromUpload();
		if (!$filename) return false;
		$obj_read_xml_file 	= new JSNReadXMLFile();
		$unpack_package		= $this->unpackPackage($filename);
		$template_manifest	= $obj_read_xml_file->getTemplateManifestFileInformation();

		$array_non_basic_module			= $this->getNonBasicModule();
		$array_non_basic_admin_module	= $this->getNonBasicAdminModule();
		$array_3rd_extension_menu		= $this->getThirdExtensionMenus();
		$domain							= $this->getDomain();
		$errors							= array();
		$isNotExsited					= array();
		$folderbackup					= $this->_template_folder_path.DS.'backups';
		if ($unpack_package)
		{
			$installed_data = $obj_read_xml_file->getSampleDataFileContent($unpack_package);
			if ($installed_data && is_array($installed_data))
			{
				$installed_data_information	= $obj_read_xml_file->getSampleDataFileInfomation($unpack_package);
				if (trim($installed_data_information['version']) != trim($template_manifest['version']))
				{
					$this->deleteSampleDataFile($filename);
					$this->deleteSampleDataFolder($unpack_package);
					$msg = 'The product version you are using is outdated. <a class="link-action" href="http://www.joomlashine.com/docs/general/how-to-update-product.html" target="_blank">How to update?</a>';
					JError::raiseWarning('SOME_ERROR_CODE', JText::_($msg));
					return false;
				}
				else
				{
					$result_check_existing_extension = $this->checkExistingExtension($installed_data);
					foreach ($result_check_existing_extension as $key => $value)
					{
						if ($value['exist'])
						{
							$extenstion_manifest = $obj_read_xml_file->getExtensionManifestFileInformation($key, $value);
							if (count($extenstion_manifest))
							{
								if (@$extenstion_manifest['version'] != $installed_data[$key]->version)
								{
    								$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'Version <strong>'.$installed_data[$key]->version.'</strong> is required. <a class="link-action" href="http://www.joomlashine.com/docs/general/how-to-update-product.html" target="_blank">How to update?</a>';
    								unset($installed_data[$key]);
								}
							}
							else
							{
								$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'the version information not found in sample data package.';
								unset($installed_data[$key]);
							}
						}
						else
						{
							$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'Extension is not installed. <a class="link-action" href="http://www.joomlashine.com/joomla-extensions/jsn-'.$key.'.html" target="_blank">Get it now.</a>';
							$isNotExsited [] = $key;
							unset($installed_data[$key]);
						}
					}
					$this->returnError('false', $errors);

					$obj_backup	= JSNBackup::getInstance();
					if (is_writable($folderbackup))
					{
						$backup_file_name 		= $obj_backup->executeBackup($this->_template_folder_path.DS.'backups', $domain, $installed_data);
					}
					$this->deleteNonBasicAdminModule();
					$this->installSampleData($installed_data);
					if (count($isNotExsited))
					{
						$this->deleteRecordAssetsTableByName($isNotExsited);
					}

					$this->runQueryNonBasicModule($array_non_basic_module);
					$this->runQueryNonBasicModule($array_non_basic_admin_module, true);
					$this->restoreThirdExtensionMenus($array_3rd_extension_menu);
					$this->rebuildMenu();
					$this->copyContentFromFilesFolder($unpack_package);
					$this->deleteSampleDataFolder($unpack_package);
					$this->setDefaultTemplate(strtolower($template_manifest['full_name']));
					$this->deleteSampleDataFile($filename);
					return true;
				}
			}
			else
			{
				$this->deleteSampleDataFile($filename);
				$msg = 'Installation file not found.';
				JError::raiseWarning('SOME_ERROR_CODE', $msg);
			}			
			return false;
		}
		else
		{
			$msg = 'Unable to extract downloaded file. Please try again.';
			JError::raiseWarning('SOME_ERROR_CODE', $msg);
		}		
		return false;
	}
}